3 # Copyright (c) 2005, Linus Torvalds
4 # Copyright (c) 2005, Junio C Hamano
6 # Clone a repository into a different directory that does not yet exist.
8 # See git-sh-setup why.
17 die "Usage: $0 [--template=<template_directory>] [--no-separate-remote] [--reference <reference-repo>] [--bare] [-l [-s]] [-q] [-u <upload-pack>] [--origin <name>] [-n] <repo> [<dir>]"
21 (cd "$1" && (cd .git ; pwd)) 2> /dev/null
24 if [ -n "$GIT_SSL_NO_VERIFY" ]; then
29 # $1 = Remote, $2 = Local
30 curl -nsfL $curl_extra_args "$1" >"$2"
34 # $1 - remote, $2 - local
36 clone_tmp="$GIT_DIR/clone-tmp" &&
37 mkdir -p "$clone_tmp" || exit 1
38 if [ -n "$GIT_CURL_FTP_NO_EPSV" -o \
39 "`git-repo-config --bool http.noEPSV`" = true ]; then
40 curl_extra_args="${curl_extra_args} --disable-epsv"
42 http_fetch "$1/info/refs" "$clone_tmp/refs" ||
43 die "Cannot get remote repository information.
44 Perhaps git-update-server-info needs to be run there?"
45 while read sha1 refname
47 name=`expr "z$refname" : 'zrefs/\(.*\)'` &&
52 yes,* | ,heads/* | ,tags/*) ;;
55 if test -n "$use_separate_remote" &&
56 branch_name=`expr "z$name" : 'zheads/\(.*\)'`
58 tname="remotes/$origin/$branch_name"
62 git-http-fetch -v -a -w "$tname" "$name" "$1/" || exit 1
63 done <"$clone_tmp/refs"
65 http_fetch "$1/HEAD" "$GIT_DIR/REMOTE_HEAD" ||
66 rm -f "$GIT_DIR/REMOTE_HEAD"
69 # Read git-fetch-pack -k output and store the remote branches.
71 use File::Path qw(mkpath);
72 use File::Basename qw(dirname);
73 my $git_dir = $ARGV[0];
74 my $use_separate_remote = $ARGV[1];
75 my $origin = $ARGV[2];
77 my $branch_top = ($use_separate_remote ? "remotes/$origin" : "heads");
81 my ($sha1, $name, $top) = @_;
82 $name = "$git_dir/refs/$top/$name";
83 mkpath(dirname($name));
89 open FH, "<", "$git_dir/CLONE_HEAD";
91 my ($sha1, $name) = /^([0-9a-f]{40})\s(.*)$/;
92 next if ($name =~ /\^\173/);
93 if ($name eq "HEAD") {
94 open O, ">", "$git_dir/REMOTE_HEAD";
99 if ($name =~ s/^refs\/heads\///) {
100 store($sha1, $name, $branch_top);
103 if ($name =~ s/^refs\/tags\///) {
104 store($sha1, $name, $tag_top);
122 use_separate_remote=t
126 *,-n|*,--no|*,--no-|*,--no-c|*,--no-ch|*,--no-che|*,--no-chec|\
127 *,--no-check|*,--no-checko|*,--no-checkou|*,--no-checkout)
129 *,--na|*,--nak|*,--nake|*,--naked|\
130 *,-b|*,--b|*,--ba|*,--bar|*,--bare) bare=yes ;;
131 *,-l|*,--l|*,--lo|*,--loc|*,--loca|*,--local) use_local=yes ;;
132 *,-s|*,--s|*,--sh|*,--sha|*,--shar|*,--share|*,--shared)
133 local_shared=yes; use_local=yes ;;
134 1,--template) usage ;;
136 shift; template="--template=$1" ;;
139 *,-q|*,--quiet) quiet=-q ;;
140 *,--use-separate-remote)
142 use_separate_remote=t ;;
143 *,--no-separate-remote)
144 use_separate_remote= ;;
145 1,--reference) usage ;;
147 shift; reference="$1" ;;
149 reference=`expr "z$1" : 'z--reference=\(.*\)'` ;;
150 *,-o|*,--or|*,--ori|*,--orig|*,--origi|*,--origin)
155 die "'$2' is not suitable for an origin name"
157 git-check-ref-format "heads/$2" ||
158 die "'$2' is not suitable for a branch name"
159 test -z "$origin_override" ||
160 die "Do not give more than one --origin options."
164 1,-u|1,--upload-pack) usage ;;
165 *,-u|*,--upload-pack)
167 upload_pack="--exec=$1" ;;
177 die 'you must specify a repository to clone.'
179 # --bare implies --no-checkout and --no-separate-remote
180 if test yes = "$bare"
182 if test yes = "$origin_override"
184 die '--bare and --origin $origin options are incompatible.'
195 # Turn the source into an absolute path if
197 if base=$(get_repo_base "$repo"); then
203 # Try using "humanish" part of source repo if user didn't specify one
204 [ -z "$dir" ] && dir=$(echo "$repo" | sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
205 [ -e "$dir" ] && die "destination directory '$dir' already exists."
207 D=$(cd "$dir" && pwd) &&
208 trap 'err=$?; cd ..; rm -rf "$D"; exit $err' 0
214 esac && export GIT_DIR && git-init-db ${template+"$template"} || usage
216 if test -n "$reference"
218 if test -d "$reference"
220 if test -d "$reference/.git/objects"
222 reference="$reference/.git"
224 reference=$(cd "$reference" && pwd)
225 echo "$reference/objects" >"$GIT_DIR/objects/info/alternates"
226 (cd "$reference" && tar cf - refs) |
227 (cd "$GIT_DIR/refs" &&
228 mkdir reference-tmp &&
232 die "reference repository '$reference' is not a local directory."
236 rm -f "$GIT_DIR/CLONE_HEAD"
238 # We do local magic only when the user tells us to.
239 case "$local,$use_local" in
241 ( cd "$repo/objects" ) ||
242 die "-l flag seen but repository '$repo' is not local."
244 case "$local_shared" in
246 # See if we can hardlink and drop "l" if not.
247 sample_file=$(cd "$repo" && \
248 find objects -type f -print | sed -e 1q)
250 # objects directory should not be empty since we are cloning!
251 test -f "$repo/$sample_file" || exit
254 if ln "$repo/$sample_file" "$GIT_DIR/objects/sample" 2>/dev/null
258 rm -f "$GIT_DIR/objects/sample" &&
260 find objects -depth -print | cpio -pumd$l "$GIT_DIR/" || exit 1
263 mkdir -p "$GIT_DIR/objects/info"
264 echo "$repo/objects" >> "$GIT_DIR/objects/info/alternates"
267 git-ls-remote "$repo" >"$GIT_DIR/CLONE_HEAD" || exit 1
272 rsync $quiet -av --ignore-existing \
273 --exclude info "$repo/objects/" "$GIT_DIR/objects/" ||
275 # Look at objects/info/alternates for rsync -- http will
276 # support it natively and git native ones will do it on the
277 # remote end. Not having that file is not a crime.
278 rsync -q "$repo/objects/info/alternates" \
279 "$GIT_DIR/TMP_ALT" 2>/dev/null ||
280 rm -f "$GIT_DIR/TMP_ALT"
281 if test -f "$GIT_DIR/TMP_ALT"
284 . git-parse-remote &&
285 resolve_alternates "$repo" <"$GIT_DIR/TMP_ALT" ) |
288 case "$alt" in 'bad alternate: '*) die "$alt";; esac
290 '') echo >&2 "Getting alternate: $alt" ;;
292 rsync $quiet -av --ignore-existing \
293 --exclude info "$alt" "$GIT_DIR/objects" || exit
295 rm -f "$GIT_DIR/TMP_ALT"
297 git-ls-remote "$repo" >"$GIT_DIR/CLONE_HEAD" || exit 1
299 https://*|http://*|ftp://*)
300 if test -z "@@NO_CURL@@"
302 clone_dumb_http "$repo" "$D"
304 die "http transport not supported, rebuild Git with curl support"
308 case "$upload_pack" in
309 '') git-fetch-pack --all -k $quiet "$repo" ;;
310 *) git-fetch-pack --all -k $quiet "$upload_pack" "$repo" ;;
311 esac >"$GIT_DIR/CLONE_HEAD" ||
312 die "fetch-pack from '$repo' failed."
317 test -d "$GIT_DIR/refs/reference-tmp" && rm -fr "$GIT_DIR/refs/reference-tmp"
319 if test -f "$GIT_DIR/CLONE_HEAD"
321 # Read git-fetch-pack -k output and store the remote branches.
322 @@PERL@@ -e "$copy_refs" "$GIT_DIR" "$use_separate_remote" "$origin" ||
328 if test -z "$bare" && test -f "$GIT_DIR/REMOTE_HEAD"
330 # Figure out which remote branch HEAD points at.
331 case "$use_separate_remote" in
332 '') remote_top=refs/heads ;;
333 *) remote_top="refs/remotes/$origin" ;;
336 head_sha1=`cat "$GIT_DIR/REMOTE_HEAD"`
339 # Uh-oh, the remote told us (http transport done against
340 # new style repository with a symref HEAD).
341 # Ideally we should skip the guesswork but for now
342 # opt for minimum change.
343 head_sha1=`expr "z$head_sha1" : 'zref: refs/heads/\(.*\)'`
344 head_sha1=`cat "$GIT_DIR/$remote_top/$head_sha1"`
348 # The name under $remote_top the remote HEAD seems to point at.
352 cd "$GIT_DIR/$remote_top" &&
353 find . -type f -print | sed -e 's/^\.\///'
358 test t = $done && continue
359 branch_tip=`cat "$GIT_DIR/$remote_top/$name"`
360 if test "$head_sha1" = "$branch_tip"
369 # Write out remotes/$origin file, and update our "$head_points_at".
370 case "$head_points_at" in
372 mkdir -p "$GIT_DIR/remotes" &&
373 git-symbolic-ref HEAD "refs/heads/$head_points_at" &&
374 case "$use_separate_remote" in
375 t) origin_track="$remote_top/$head_points_at"
376 git-update-ref HEAD "$head_sha1" ;;
377 *) origin_track="$remote_top/$origin"
378 git-update-ref "refs/heads/$origin" "$head_sha1" ;;
380 git-repo-config remote."$origin".url "$repo" &&
381 git-repo-config remote."$origin".fetch \
382 "refs/heads/$head_points_at:$origin_track" &&
383 (cd "$GIT_DIR/$remote_top" && find . -type f -print) |
386 name=`expr "$dotslref" : './\(.*\)'`
387 if test "z$head_points_at" = "z$name"
391 if test "$use_separate_remote" = '' &&
392 test "z$origin" = "z$name"
396 git-repo-config remote."$origin".fetch "refs/heads/${name}:$remote_top/${name}" '^$'
398 case "$use_separate_remote" in
400 rm -f "refs/remotes/$origin/HEAD"
401 git-symbolic-ref "refs/remotes/$origin/HEAD" \
402 "refs/remotes/$origin/$head_points_at"
404 git-repo-config branch."$head_points_at".remote "$origin" &&
405 git-repo-config branch."$head_points_at".merge "refs/heads/$head_points_at"
408 case "$no_checkout" in
410 test "z$quiet" = z && v=-v || v=
411 git-read-tree -m -u $v HEAD HEAD
414 rm -f "$GIT_DIR/CLONE_HEAD" "$GIT_DIR/REMOTE_HEAD"